Index: uspace/lib/posix/Makefile
===================================================================
--- uspace/lib/posix/Makefile	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/Makefile	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,27 +37,16 @@
 LIBC_FILE = $(LIBC_PREFIX)/libc.a
 
+FIXED_POSIX_LIBRARY = libposixaslibc.a
 FIXED_C_LIBRARY = libc4posix.a
 MERGED_C_LIBRARY = libc.a
 MERGE_LIBRARIES = \
 	$(FIXED_C_LIBRARY) \
-	$(LIBRARY).a \
+	$(FIXED_POSIX_LIBRARY) \
 	$(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a \
 	$(LIBSOFTINT_PREFIX)/libsoftint.a
 
-SPECS = gcc.specs
-LIBC_LINKER_SCRIPT = $(LIBC_PREFIX)/arch/$(UARCH)/_link.ld
-LIBC_STARTUP_FILE = $(shell sed -n -e 's/^.*STARTUP(\(.*\)).*$$/\1/p' $(LIBC_LINKER_SCRIPT))
-EXPORT_LINKER_SCRIPT = link.ld
-EXPORT_STARTUP_FILE = crt0.o
-
-EXPORT_FILES = \
-	../math/libmath.a \
-	../clui/libclui.a \
-	$(MERGED_C_LIBRARY) \
-	$(EXPORT_STARTUP_FILE) \
-	$(EXPORT_LINKER_SCRIPT) \
-	$(SPECS)
-
 REDEFS_HIDE_LIBC = redefs-hide-libc-symbols.list
+REDEFS_SHOW_LIBPOSIX = redefs-show-posix-symbols.list
+COLLISIONS_LIST = collisions.list
 
 PRE_DEPEND = $(INCLUDE_LIBC)
@@ -65,31 +54,36 @@
 	$(INCLUDE_LIBC) \
 	$(REDEFS_HIDE_LIBC) \
+	$(REDEFS_SHOW_LIBPOSIX) \
+	$(COLLISIONS_LIST) \
 	libc.o
 
-EXTRA_OUTPUT = $(FIXED_C_LIBRARY) $(FIXED_POSIX_LIBRARY) $(MERGED_C_LIBRARY) $(SPECS) $(EXPORT_LINKER_SCRIPT) $(EXPORT_STARTUP_FILE)
+EXTRA_OUTPUT = $(FIXED_C_LIBRARY) $(FIXED_POSIX_LIBRARY) $(MERGED_C_LIBRARY)
 
 SOURCES = \
-	src/ctype.c \
-	src/dlfcn.c \
-	src/fcntl.c \
-	src/fnmatch.c \
-	src/locale.c \
-	src/pthread/condvar.c \
-	src/pthread/keys.c \
-	src/pthread/mutex.c \
-	src/pthread/threads.c \
-	src/pwd.c \
-	src/signal.c \
-	src/stdio.c \
-	src/stdio/scanf.c \
-	src/stdlib.c \
-	src/stdlib/strtold.c \
-	src/string.c \
-	src/strings.c \
-	src/sys/mman.c \
-	src/sys/stat.c \
-	src/sys/wait.c \
-	src/time.c \
-	src/unistd.c
+	source/ctype.c \
+	source/dlfcn.c \
+	source/errno.c \
+	source/fcntl.c \
+	source/fnmatch.c \
+	source/getopt.c \
+	source/locale.c \
+	source/pthread/condvar.c \
+	source/pthread/keys.c \
+	source/pthread/mutex.c \
+	source/pthread/threads.c \
+	source/pwd.c \
+	source/signal.c \
+	source/stdio.c \
+	source/stdio/scanf.c \
+	source/stdlib.c \
+	source/stdlib/strtol.c \
+	source/stdlib/strtold.c \
+	source/string.c \
+	source/strings.c \
+	source/sys/mman.c \
+	source/sys/stat.c \
+	source/sys/wait.c \
+	source/time.c \
+	source/unistd.c
 
 TEST_SOURCES = \
@@ -97,83 +91,16 @@
 	test/scanf.c
 
-EXPORT_CPPFLAGS = \
-	-specs $$(HELENOS_EXPORT_ROOT)/lib/gcc.specs \
-	-isystem $$(HELENOS_EXPORT_ROOT)/include
-
-EXPORT_LDFLAGS = \
-	-L$$(HELENOS_EXPORT_ROOT)/lib \
-	--whole-archive -lc -lmath --no-whole-archive \
-	-T link.ld
-
-EXPORT_CFLAGS = \
-	$(EXPORT_CPPFLAGS) \
-	$(addprefix -Xlinker , $(EXPORT_LDFLAGS))
-
 include $(USPACE_PREFIX)/Makefile.common
 
-$(SPECS): $(CONFIG_MAKEFILE)
-	echo '*self_spec:' > $@.new
-	echo '+ $(COMMON_CFLAGS)' >> $@.new
-	echo >> $@.new
-	echo '*lib:' >> $@.new
-	echo '--whole-archive -lc -lmath --no-whole-archive' >> $@.new
-	echo >> $@.new
-	mv $@.new $@
+$(INCLUDE_LIBC): ../c/include
+	ln -s -f -n ../$^ $@
 
-$(EXPORT_LINKER_SCRIPT): $(LIBC_LINKER_SCRIPT)
-	sed 's/STARTUP(.*)/STARTUP(crt0.o)/' $< > $@
+$(FIXED_C_LIBRARY): $(LIBC_FILE) $(REDEFS_HIDE_LIBC) $(REDEFS_SHOW_LIBPOSIX)
+	$(OBJCOPY) --redefine-syms=$(REDEFS_HIDE_LIBC) $(LIBC_FILE) $@
+	$(OBJCOPY) --redefine-syms=$(REDEFS_SHOW_LIBPOSIX) $@ $@
 
-$(EXPORT_STARTUP_FILE): $(LIBC_STARTUP_FILE)
-	cp $< $@
-
-$(INCLUDE_LIBC): $(shell find ../c/include -name '*.h')
-	cp -r -L --remove-destination -T ../c/include $@
-	find ../c/include -type f -and -not -name '*.h' -delete
-
-export: $(EXPORT_DIR)/config.mk $(EXPORT_DIR)/config.rc
-
-$(EXPORT_DIR)/config.mk: export-libs export-includes
-	echo '# Generated file, do not modify.' >> $@.new
-	echo '# Do not forget to set HELENOS_EXPORT_ROOT.' >> $@.new
-	echo 'HELENOS_CROSS_PATH="$(shell dirname $(CC))"' >> $@.new
-	echo 'HELENOS_TARGET="$(TARGET)"' >> $@.new
-	echo 'HELENOS_CPPFLAGS="$(EXPORT_CPPFLAGS)"' >> $@.new
-	echo 'HELENOS_CFLAGS="$(EXPORT_CFLAGS)"' >> $@.new
-	echo 'HELENOS_LDFLAGS="$(EXPORT_LDFLAGS)"' >> $@.new
-	mv $@.new $@
-
-$(EXPORT_DIR)/config.rc: $(EXPORT_DIR)/config.mk
-	sed 's:$$(HELENOS_EXPORT_ROOT):$$HELENOS_EXPORT_ROOT:g' < $< >$@
-
-export-libs: $(EXPORT_FILES) export-includes
-	mkdir -p $(EXPORT_DIR)/lib
-	cp -L $(EXPORT_FILES) $(EXPORT_DIR)/lib
-
-export-includes: $(INCLUDE_LIBC) $(shell find ./include ../c/arch/$(UARCH)/include $(ROOT_PATH)/abi/include -name '*.h')
-	mkdir -p $(EXPORT_DIR)/include
-	rm -rf $(EXPORT_DIR)/include.new
-	cp -r -L -T ./include/posix $(EXPORT_DIR)/include.new
-	cp -r -L -T ./include/libc $(EXPORT_DIR)/include.new/libc
-	cp -r -L ../c/arch/$(UARCH)/include/* $(EXPORT_DIR)/include.new/libc
-	cp -r -L $(ROOT_PATH)/abi/include/* $(EXPORT_DIR)/include.new
-	mkdir -p $(EXPORT_DIR)/include.new/libclui
-	cp -L ../clui/tinput.h $(EXPORT_DIR)/include.new/libclui
-	
-	find "$(EXPORT_DIR)/include.new/libc" "$(EXPORT_DIR)/include.new/libclui" -name '*.h' -exec sed \
-		-e 's:#include <:#include <libc/:' \
-		-e 's:#include <libc/abi/:#include <abi/:' \
-		-e 's:#include <libc/_bits/:#include <_bits/:' \
-		-e 's:#include <libc/libc/:#include <libc/:' \
-		-i {} \;
-	find "$(EXPORT_DIR)/include.new" -name '*.h' -exec sed \
-		-e 's:#include "posix/:#include ":' \
-		-e 's:#include <posix/:#include <:' \
-		-i {} \;
-	
-	rm -rf $(EXPORT_DIR)/include
-	mv $(EXPORT_DIR)/include.new $(EXPORT_DIR)/include
-
-$(FIXED_C_LIBRARY): $(LIBC_FILE) $(REDEFS_HIDE_LIBC)
-	$(OBJCOPY) --redefine-syms=$(REDEFS_HIDE_LIBC) $(LIBC_FILE) $@
+$(FIXED_POSIX_LIBRARY): $(LIBRARY).a $(REDEFS_HIDE_LIBC) $(REDEFS_SHOW_LIBPOSIX)
+	$(OBJCOPY) --redefine-syms=$(REDEFS_HIDE_LIBC) $(LIBRARY).a $@
+	$(OBJCOPY) --redefine-syms=$(REDEFS_SHOW_LIBPOSIX) $@ $@
 
 $(MERGED_C_LIBRARY): $(MERGE_LIBRARIES)
@@ -181,4 +108,13 @@
 	$(AR) rc $@ libc.o
 
-$(REDEFS_HIDE_LIBC): $(SOURCES)
-	sed -n -e 's/_HIDE_LIBC_SYMBOL(\(.*\))/\1 __helenos_libc_\1/p' $(SOURCES) >$@
+$(REDEFS_HIDE_LIBC): $(COLLISIONS_LIST)
+	sed 's/.*/& __helenos_libc_&/' <$(COLLISIONS_LIST) >$@
+
+$(REDEFS_SHOW_LIBPOSIX): $(COLLISIONS_LIST)
+	sed 's/.*/posix_& &/' <$(COLLISIONS_LIST) >$@
+
+$(COLLISIONS_LIST): include/posix/*.h include/posix/*/*.h
+	find ./include/posix -name '*.h' -exec \
+		sed -n -e '/^#/d' -e 's/__POSIX_DEF__/\n&/gp' {} \; | \
+		sed -n -e 's/__POSIX_DEF__(\([^)]*\)).*/\1/p' | \
+		sort -u >$@
Index: uspace/lib/posix/include/posix/assert.h
===================================================================
--- uspace/lib/posix/include/posix/assert.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/assert.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -1,1 +1,48 @@
+/*
+ * Copyright (c) 2011 Jiri Zarevucky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libposix
+ * @{
+ */
+/** @file Program assertion.
+ */
+
+/* NO include guard on purpose. */
+
 #include "libc/assert.h"
+
+#undef assert
+
+#ifndef NDEBUG
+	#define assert(expr) ((expr) ? (void) 0 : assert_abort(#expr, __FILE__, __LINE__))
+#else
+	#define assert(expr) ((void) 0)
+#endif
+
+/** @}
+ */
Index: uspace/lib/posix/include/posix/ctype.h
===================================================================
--- uspace/lib/posix/include/posix/ctype.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/ctype.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,12 +37,27 @@
 #define POSIX_CTYPE_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include "libc/ctype.h"
 
+/* Classification of Characters */
+extern int __POSIX_DEF__(isxdigit)(int c);
+extern int __POSIX_DEF__(isblank)(int c);
+extern int __POSIX_DEF__(iscntrl)(int c);
+extern int __POSIX_DEF__(isgraph)(int c);
+extern int __POSIX_DEF__(isprint)(int c);
+extern int __POSIX_DEF__(ispunct)(int c);
+
 /* Obsolete Functions and Macros */
-extern int isascii(int c);
-extern int toascii(int c);
+extern int __POSIX_DEF__(isascii)(int c);
+extern int __POSIX_DEF__(toascii)(int c);
+#undef _tolower
+#define _tolower(c) ((c) - 'A' + 'a')
+#undef _toupper
+#define _toupper(c) ((c) - 'a' + 'A')
 
-#define _tolower(c) ((c) - 'A' + 'a')
-#define _toupper(c) ((c) - 'a' + 'A')
+
 
 #endif /* POSIX_CTYPE_H_ */
Index: uspace/lib/posix/include/posix/dirent.h
===================================================================
--- uspace/lib/posix/include/posix/dirent.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/dirent.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,4 +36,8 @@
 #define POSIX_DIRENT_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include <libc/dirent.h>
 
Index: uspace/lib/posix/include/posix/dlfcn.h
===================================================================
--- uspace/lib/posix/include/posix/dlfcn.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/dlfcn.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -34,5 +34,7 @@
 #define POSIX_DLFCN_H_
 
-#include "libc/dlfcn.h"
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
 
 #define RTLD_LAZY 1
@@ -41,8 +43,10 @@
 #define RTLD_LOCAL 0
 
-extern void *dlopen(const char *, int);
-extern void *dlsym(void *, const char *);
-extern int dlclose(void *);
-extern char *dlerror(void);
+
+extern void *__POSIX_DEF__(dlopen)(const char *, int);
+extern void *__POSIX_DEF__(dlsym)(void *, const char *);
+extern int __POSIX_DEF__(dlclose)(void *);
+extern char *__POSIX_DEF__(dlerror)(void);
+
 
 #endif
Index: uspace/lib/posix/include/posix/errno.h
===================================================================
--- uspace/lib/posix/include/posix/errno.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/errno.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -1,1 +1,326 @@
+/*
+ * Copyright (c) 2011 Jiri Zarevucky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libposix
+ * @{
+ */
+/** @file System error numbers.
+ */
+
+#ifndef POSIX_ERRNO_H_
+#define POSIX_ERRNO_H_
+
 #include "libc/errno.h"
+
+/* IMPORTANT:
+ * Since libc uses negative errorcodes, some sort of conversion is necessary to
+ * keep POSIX programs and libraries from breaking. This file maps POSIX error
+ * codes to absolute values of corresponding libc codes where available, and
+ * assigns new code where there is no prior definition in libc.
+ *
+ * A new errno variable is defined. When accessed, the function first looks at
+ * libc errno and iff it is != 0, sets the POSIX errno to absolute value of
+ * libc errno. Given that no library function sets errno to 0 and that all
+ * POSIX libraries will be used solely by POSIX programs (thus, there only needs
+ * to be one way correspondence between errno and posix_errno), this approach
+ * should work as expected in most cases and does not require any wrappers for
+ * libc routines that would just change errno values.
+ *
+ * There is no conditioning by LIBPOSIX_INTERNAL for redefinitions of macros.
+ * If there is a need to check errno for a value not defined by POSIX, it's
+ * necessary to compare errno against abs(ECODE), because there is no
+ * redefinition for such error codes.
+ *
+ * XXX: maybe all HOS error codes should be redefined
+ *
+ * NOTE: This redefinition is slightly POSIX incompatible, since the
+ *  specification requires the macro values to be usable in preprocessing
+ *  directives. I don't think that's very important, though.
+ */
+
+#undef errno
+#define errno (*__posix_errno())
+
+extern int *__posix_errno(void);
+
+#define __TOP_ERRNO (-EAGAIN)
+
+enum {
+	POSIX_E2BIG = __TOP_ERRNO + 1,
+	POSIX_EACCES = __TOP_ERRNO + 2,
+	POSIX_EADDRNOTAVAIL = -EADDRNOTAVAIL,
+	POSIX_EAGAIN = -EAGAIN,
+	POSIX_EALREADY = __TOP_ERRNO + 3,
+	POSIX_EBADF = -EBADF,
+	POSIX_EBADMSG = __TOP_ERRNO + 4,
+	POSIX_EBUSY = -EBUSY,
+	POSIX_ECANCELED = __TOP_ERRNO + 5,
+	POSIX_ECHILD = __TOP_ERRNO + 6,
+	POSIX_ECONNABORTED = __TOP_ERRNO + 7,
+	POSIX_ECONNREFUSED = __TOP_ERRNO + 8,
+	POSIX_ECONNRESET = __TOP_ERRNO + 9,
+	POSIX_EDEADLK = __TOP_ERRNO + 10,
+	POSIX_EDOM = __TOP_ERRNO + 11,
+	POSIX_EDQUOT = __TOP_ERRNO + 12,
+	POSIX_EEXIST = -EEXIST,
+	POSIX_EFAULT = __TOP_ERRNO + 13,
+	POSIX_EFBIG = __TOP_ERRNO + 14,
+	POSIX_EHOSTUNREACH = __TOP_ERRNO + 15,
+	POSIX_EIDRM = __TOP_ERRNO + 16,
+	POSIX_EILSEQ = __TOP_ERRNO + 17,
+	POSIX_EINTR = -EINTR,
+	POSIX_EINVAL = -EINVAL,
+	POSIX_EIO = -EIO,
+	POSIX_EISCONN = __TOP_ERRNO + 18,
+	POSIX_EISDIR = -EISDIR,
+	POSIX_ELOOP = __TOP_ERRNO + 19,
+	POSIX_EMFILE = -EMFILE,
+	POSIX_EMLINK = -EMLINK,
+	POSIX_EMSGSIZE = __TOP_ERRNO + 20,
+	POSIX_EMULTIHOP = __TOP_ERRNO + 21,
+	POSIX_ENAMETOOLONG = -ENAMETOOLONG,
+	POSIX_ENETDOWN = __TOP_ERRNO + 22,
+	POSIX_ENETRESET = __TOP_ERRNO + 23,
+	POSIX_ENETUNREACH = __TOP_ERRNO + 24,
+	POSIX_ENFILE = __TOP_ERRNO + 25,
+	POSIX_ENOBUFS = __TOP_ERRNO + 26,
+	POSIX_ENODEV = __TOP_ERRNO + 27,
+	POSIX_ENOENT = -ENOENT,
+	POSIX_ENOEXEC = __TOP_ERRNO + 28,
+	POSIX_ENOLCK = __TOP_ERRNO + 29,
+	POSIX_ENOLINK = __TOP_ERRNO + 30,
+	POSIX_ENOMEM = -ENOMEM,
+	POSIX_ENOMSG = __TOP_ERRNO + 31,
+	POSIX_ENOPROTOOPT = __TOP_ERRNO + 32,
+	POSIX_ENOSPC = -ENOSPC,
+	POSIX_ENOSR = __TOP_ERRNO + 33,
+	POSIX_ENOSTR = __TOP_ERRNO + 34,
+	POSIX_ENOSYS = __TOP_ERRNO + 35,
+	POSIX_ENOTDIR = -ENOTDIR,
+	POSIX_ENOTEMPTY = -ENOTEMPTY,
+	POSIX_ENOTRECOVERABLE = __TOP_ERRNO + 36,
+	POSIX_ENOTSUP = -ENOTSUP,
+	POSIX_ENOTTY = __TOP_ERRNO + 37,
+	POSIX_ENXIO = __TOP_ERRNO + 38,
+	POSIX_EOPNOTSUPP = __TOP_ERRNO + 39,
+	POSIX_EOVERFLOW = -EOVERFLOW,
+	POSIX_EOWNERDEAD = __TOP_ERRNO + 40,
+	POSIX_EPERM = -EPERM,
+	POSIX_EPIPE = __TOP_ERRNO + 41,
+	POSIX_EPROTO = __TOP_ERRNO + 42,
+	POSIX_EPROTOTYPE = __TOP_ERRNO + 43,
+	POSIX_ERANGE = -ERANGE,
+	POSIX_EROFS = __TOP_ERRNO + 44,
+	POSIX_ESPIPE = __TOP_ERRNO + 45,
+	POSIX_ESRCH = __TOP_ERRNO + 46,
+	POSIX_ESTALE = __TOP_ERRNO + 47,
+	POSIX_ETIME = __TOP_ERRNO + 48,
+	POSIX_ETIMEDOUT = __TOP_ERRNO + 49,
+	POSIX_ETXTBSY = __TOP_ERRNO + 50,
+	POSIX_EWOULDBLOCK = __TOP_ERRNO + 51,
+	POSIX_EXDEV = -EXDEV,
+	POSIX_EINPROGRESS = __TOP_ERRNO + 52,
+	POSIX_ENOTSOCK = __TOP_ERRNO + 53,
+	POSIX_EDESTADDRREQ = __TOP_ERRNO + 54,
+	POSIX_EPROTONOSUPPORT = __TOP_ERRNO + 55,
+	POSIX_EAFNOSUPPORT = __TOP_ERRNO + 56,
+	POSIX_EADDRINUSE = __TOP_ERRNO + 57,
+	POSIX_ENOTCONN = __TOP_ERRNO + 58,
+	POSIX_ENODATA = __TOP_ERRNO + 59,
+};
+
+#undef __TOP_ERRNO
+
+#undef E2BIG
+#undef EACCES
+#undef EADDRINUSE
+#undef EADDRNOTAVAIL
+#undef EAFNOSUPPORT
+#undef EAGAIN
+#undef EALREADY
+#undef EBADF
+#undef EBADMSG
+#undef EBUSY
+#undef ECANCELED
+#undef ECHILD
+#undef ECONNABORTED
+#undef ECONNREFUSED
+#undef ECONNRESET
+#undef EDEADLK
+#undef EDESTADDRREQ
+#undef EDOM
+#undef EDQUOT
+#undef EEXIST
+#undef EFAULT
+#undef EFBIG
+#undef EHOSTUNREACH
+#undef EIDRM
+#undef EILSEQ
+#undef EINPROGRESS
+#undef EINTR
+#undef EINVAL
+#undef EIO
+#undef EISCONN
+#undef EISDIR
+#undef ELOOP
+#undef EMFILE
+#undef EMLINK
+#undef EMSGSIZE
+#undef EMULTIHOP
+#undef ENAMETOOLONG
+#undef ENETDOWN
+#undef ENETRESET
+#undef ENETUNREACH
+#undef ENFILE
+#undef ENOBUFS
+#undef ENODATA
+#undef ENODEV
+#undef ENOENT
+#undef ENOEXEC
+#undef ENOLCK
+#undef ENOLINK
+#undef ENOMEM
+#undef ENOMSG
+#undef ENOPROTOOPT
+#undef ENOSPC
+#undef ENOSR
+#undef ENOSTR
+#undef ENOSYS
+#undef ENOTCONN
+#undef ENOTDIR
+#undef ENOTEMPTY
+#undef ENOTRECOVERABLE
+#undef ENOTSOCK
+#undef ENOTSUP
+#undef ENOTTY
+#undef ENXIO
+#undef EOPNOTSUPP
+#undef EOVERFLOW
+#undef EOWNERDEAD
+#undef EPERM
+#undef EPIPE
+#undef EPROTO
+#undef EPROTONOSUPPORT
+#undef EPROTOTYPE
+#undef ERANGE
+#undef EROFS
+#undef ESPIPE
+#undef ESRCH
+#undef ESTALE
+#undef ETIME
+#undef ETIMEDOUT
+#undef ETXTBSY
+#undef EWOULDBLOCK
+#undef EXDEV
+
+#define E2BIG POSIX_E2BIG
+#define EACCES POSIX_EACCES
+#define EADDRINUSE POSIX_EADDRINUSE
+#define EADDRNOTAVAIL POSIX_EADDRNOTAVAIL
+#define EAFNOSUPPORT POSIX_EAFNOSUPPORT
+#define EAGAIN POSIX_EAGAIN
+#define EALREADY POSIX_EALREADY
+#define EBADF POSIX_EBADF
+#define EBADMSG POSIX_EBADMSG
+#define EBUSY POSIX_EBUSY
+#define ECANCELED POSIX_ECANCELED
+#define ECHILD POSIX_ECHILD
+#define ECONNABORTED POSIX_ECONNABORTED
+#define ECONNREFUSED POSIX_ECONNREFUSED
+#define ECONNRESET POSIX_ECONNRESET
+#define EDEADLK POSIX_EDEADLK
+#define EDESTADDRREQ POSIX_EDESTADDRREQ
+#define EDOM POSIX_EDOM
+#define EDQUOT POSIX_EDQUOT
+#define EEXIST POSIX_EEXIST
+#define EFAULT POSIX_EFAULT
+#define EFBIG POSIX_EFBIG
+#define EHOSTUNREACH POSIX_EHOSTUNREACH
+#define EIDRM POSIX_EIDRM
+#define EILSEQ POSIX_EILSEQ
+#define EINPROGRESS POSIX_EINPROGRESS
+#define EINTR POSIX_EINTR
+#define EINVAL POSIX_EINVAL
+#define EIO POSIX_EIO
+#define EISCONN POSIX_EISCONN
+#define EISDIR POSIX_EISDIR
+#define ELOOP POSIX_ELOOP
+#define EMFILE POSIX_EMFILE
+#define EMLINK POSIX_EMLINK
+#define EMSGSIZE POSIX_EMSGSIZE
+#define EMULTIHOP POSIX_EMULTIHOP
+#define ENAMETOOLONG POSIX_ENAMETOOLONG
+#define ENETDOWN POSIX_ENETDOWN
+#define ENETRESET POSIX_ENETRESET
+#define ENETUNREACH POSIX_ENETUNREACH
+#define ENFILE POSIX_ENFILE
+#define ENOBUFS POSIX_ENOBUFS
+#define ENODATA POSIX_ENODATA
+#define ENODEV POSIX_ENODEV
+#define ENOENT POSIX_ENOENT
+#define ENOEXEC POSIX_ENOEXEC
+#define ENOLCK POSIX_ENOLCK
+#define ENOLINK POSIX_ENOLINK
+#define ENOMEM POSIX_ENOMEM
+#define ENOMSG POSIX_ENOMSG
+#define ENOPROTOOPT POSIX_ENOPROTOOPT
+#define ENOSPC POSIX_ENOSPC
+#define ENOSR POSIX_ENOSR
+#define ENOSTR POSIX_ENOSTR
+#define ENOSYS POSIX_ENOSYS
+#define ENOTCONN POSIX_ENOTCONN
+#define ENOTDIR POSIX_ENOTDIR
+#define ENOTEMPTY POSIX_ENOTEMPTY
+#define ENOTRECOVERABLE POSIX_ENOTRECOVERABLE
+#define ENOTSOCK POSIX_ENOTSOCK
+#define ENOTSUP POSIX_ENOTSUP
+#define ENOTTY POSIX_ENOTTY
+#define ENXIO POSIX_ENXIO
+#define EOPNOTSUPP POSIX_EOPNOTSUPP
+#define EOVERFLOW POSIX_EOVERFLOW
+#define EOWNERDEAD POSIX_EOWNERDEAD
+#define EPERM POSIX_EPERM
+#define EPIPE POSIX_EPIPE
+#define EPROTO POSIX_EPROTO
+#define EPROTONOSUPPORT POSIX_EPROTONOSUPPORT
+#define EPROTOTYPE POSIX_EPROTOTYPE
+#define ERANGE POSIX_ERANGE
+#define EROFS POSIX_EROFS
+#define ESPIPE POSIX_ESPIPE
+#define ESRCH POSIX_ESRCH
+#define ESTALE POSIX_ESTALE
+#define ETIME POSIX_ETIME
+#define ETIMEDOUT POSIX_ETIMEDOUT
+#define ETXTBSY POSIX_ETXTBSY
+#define EWOULDBLOCK POSIX_EWOULDBLOCK
+#define EXDEV POSIX_EXDEV
+
+#endif /* POSIX_ERRNO_H_ */
+
+/** @}
+ */
Index: uspace/lib/posix/include/posix/fcntl.h
===================================================================
--- uspace/lib/posix/include/posix/fcntl.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/fcntl.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,10 @@
 #define POSIX_FCNTL_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include "sys/types.h"
+#include "errno.h"
 
 #undef O_CREAT
@@ -89,6 +94,7 @@
 #define FD_CLOEXEC         1 /* Close on exec. */
 
-extern int open(const char *pathname, int flags, ...);
-extern int fcntl(int fd, int cmd, ...);
+extern int __POSIX_DEF__(open)(const char *pathname, int flags, ...);
+extern int __POSIX_DEF__(fcntl)(int fd, int cmd, ...);
+
 
 #endif /* POSIX_FCNTL_H_ */
Index: uspace/lib/posix/include/posix/fnmatch.h
===================================================================
--- uspace/lib/posix/include/posix/fnmatch.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/fnmatch.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,4 +36,8 @@
 #define POSIX_FNMATCH_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 /* Error Values */
 #undef FNM_NOMATCH
@@ -56,5 +60,5 @@
 #define FNM_CASEFOLD 16
 
-extern int fnmatch(const char *pattern, const char *string, int flags);
+extern int __POSIX_DEF__(fnmatch)(const char *pattern, const char *string, int flags);
 
 
Index: uspace/lib/posix/include/posix/getopt.h
===================================================================
--- uspace/lib/posix/include/posix/getopt.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/getopt.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -35,6 +35,26 @@
 #define POSIX_GETOPT_H
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include "unistd.h"
-#include "libc/getopt.h"
+
+/* Option Arguments */
+#define no_argument        0
+#define required_argument  1
+#define optional_argument  2
+
+#ifndef LIBPOSIX_INTERNAL
+struct option {
+	const char *name;
+	int has_arg;
+	int *flag;
+	int val;
+};
+#endif
+
+extern int __POSIX_DEF__(getopt_long)(int, char * const [], const char *, const struct option *, int *);
+
 
 #endif
Index: uspace/lib/posix/include/posix/inttypes.h
===================================================================
--- uspace/lib/posix/include/posix/inttypes.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/inttypes.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,6 +36,16 @@
 #define POSIX_INTTYPES_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include "stdint.h"
 #include "libc/inttypes.h"
+
+extern intmax_t __POSIX_DEF__(strtoimax)(const char *__restrict__ nptr,
+    char **__restrict__ endptr, int base);
+extern uintmax_t __POSIX_DEF__(strtoumax)(const char *__restrict__ nptr,
+    char **__restrict__ endptr, int base);
+
 
 #endif /* POSIX_INTTYPES_H_ */
Index: uspace/lib/posix/include/posix/locale.h
===================================================================
--- uspace/lib/posix/include/posix/locale.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/locale.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,9 +36,16 @@
 #define POSIX_LOCALE_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include <_bits/NULL.h>
 
 #ifndef __locale_t_defined
-#define __locale_t_defined
-typedef struct __posix_locale *locale_t;
+	#define __locale_t_defined
+	typedef struct __posix_locale *__POSIX_DEF__(locale_t);
+	#ifndef LIBPOSIX_INTERNAL
+		#define locale_t __POSIX_DEF__(locale_t)
+	#endif
 #endif
 
@@ -77,5 +84,5 @@
 #define LC_GLOBAL_LOCALE NULL
 
-struct lconv {
+struct __POSIX_DEF__(lconv) {
 	char *currency_symbol;
 	char *decimal_point;
@@ -104,13 +111,13 @@
 };
 
-extern char *setlocale(int category, const char *locale);
-extern struct lconv *localeconv(void);
+extern char *__POSIX_DEF__(setlocale)(int category, const char *locale);
+extern struct __POSIX_DEF__(lconv) *__POSIX_DEF__(localeconv)(void);
 
 /* POSIX Extensions */
-extern locale_t duplocale(locale_t locobj);
-extern void freelocale(locale_t locobj);
-extern locale_t newlocale(int category_mask, const char *locale,
-    locale_t base);
-extern locale_t uselocale(locale_t newloc);
+extern __POSIX_DEF__(locale_t) __POSIX_DEF__(duplocale)(__POSIX_DEF__(locale_t) locobj);
+extern void __POSIX_DEF__(freelocale)(__POSIX_DEF__(locale_t) locobj);
+extern __POSIX_DEF__(locale_t) __POSIX_DEF__(newlocale)(int category_mask, const char *locale,
+    __POSIX_DEF__(locale_t) base);
+extern __POSIX_DEF__(locale_t) __POSIX_DEF__(uselocale)(__POSIX_DEF__(locale_t) newloc);
 
 
Index: uspace/lib/posix/include/posix/pthread.h
===================================================================
--- uspace/lib/posix/include/posix/pthread.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/pthread.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -32,4 +32,8 @@
 #ifndef POSIX_PTHREAD_H_
 #define POSIX_PTHREAD_H_
+
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
 
 #include "libc/thread.h"
@@ -95,5 +99,5 @@
 extern int pthread_cond_signal(pthread_cond_t *);
 extern int pthread_cond_timedwait(pthread_cond_t *__restrict__,
-    pthread_mutex_t *__restrict__, const struct timespec *__restrict__);
+    pthread_mutex_t *__restrict__, const struct __POSIX_DEF__(timespec) *__restrict__);
 extern int pthread_cond_wait(pthread_cond_t *__restrict__,
     pthread_mutex_t *__restrict__);
@@ -105,5 +109,5 @@
 extern int pthread_setspecific(pthread_key_t, const void *);
 extern int pthread_key_delete(pthread_key_t);
-extern int pthread_key_create(pthread_key_t *, void (*)(void *));
+extern int pthread_key_create(pthread_key_t *, void (*)(void*));
 
 #endif
Index: uspace/lib/posix/include/posix/pwd.h
===================================================================
--- uspace/lib/posix/include/posix/pwd.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/include/posix/pwd.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,25 +36,29 @@
 #define POSIX_PWD_H_
 
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
 #include "sys/types.h"
 
-struct passwd {
+struct __POSIX_DEF__(passwd) {
 	char *pw_name;
-	uid_t pw_uid;
-	gid_t pw_gid;
+	__POSIX_DEF__(uid_t) pw_uid;
+	__POSIX_DEF__(gid_t) pw_gid;
 	char *pw_dir;
 	char *pw_shell;
 };
 
-extern struct passwd *getpwent(void);
-extern void setpwent(void);
-extern void endpwent(void);
+extern struct __POSIX_DEF__(passwd) *__POSIX_DEF__(getpwent)(void);
+extern void __POSIX_DEF__(setpwent)(void);
+extern void __POSIX_DEF__(endpwent)(void);
 
-extern struct passwd *getpwnam(const char *name);
-extern int getpwnam_r(const char *name, struct passwd *pwd,
-    char *buffer, size_t bufsize, struct passwd **result);
+extern struct __POSIX_DEF__(passwd) *__POSIX_DEF__(getpwnam)(const char *name);
+extern int __POSIX_DEF__(getpwnam_r)(const char *name, struct __POSIX_DEF__(passwd) *pwd,
+    char *buffer, size_t bufsize, struct __POSIX_DEF__(passwd) **result);
 
-extern struct passwd *getpwuid(uid_t uid);
-extern int getpwuid_r(uid_t uid, struct passwd *pwd,
-    char *buffer, size_t bufsize, struct passwd **result);
+extern struct __POSIX_DEF__(passwd) *__POSIX_DEF__(getpwuid)(__POSIX_DEF__(uid_t) uid);
+extern int __POSIX_DEF__(getpwuid_r)(__POSIX_DEF__(uid_t) uid, struct __POSIX_DEF__(passwd) *pwd,
+    char *buffer, size_t bufsize, struct __POSIX_DEF__(passwd) **result);
 
 
